SysY 语言的文法采用拓展的 Backus 范式（EBNF）表示，这里为了消除左递归，用新的形式重写一遍，其中：
- 符号 `[...]` 表示方括号内包含的为可选项（出现 0 次或 1 次）
- 符号 `{...}` 表示花括号内包含的为重复项（出现 0 次到多次）
- 符号 `(...)` 与数学中的括号类似，其中的运算有更高的优先级
- 符号 `|` 表示在多个之中选择一个
- “终结符”或者是单引号扩起的串，或者是 Ident, InstConst, FloatConst 这样的记号

需要修改的部分文法表示如下，其中 CompUnit 为开始符号：

|     名称 |      标识符 |   | 内容                                               |
|-------:|---------:|---|:-------------------------------------------------|
|   编译单元 | CompUnit | → | ( Decl \| FuncDef ) { ( Decl \| FuncDef ) }      |
| 乘除模表达式 |   MulExp | → | UnaryExp { ( '*' \| '/' \| '%' ) UnaryExp }      | 
|  加减表达式 |   AddExp | → | MulExp { ( '+' \| '-' ) MulExp }                 | 
|  关系表达式 |   RelExp | → | AddExp { ( '<' \| '>' \| '<=' \| '>=' ) AddExp } | 
| 相等性表达式 |    EqExp | → | RelExp { ( '==' \| '!=' ) RelExp }               | 
| 逻辑与表达式 |  LAndExp | → | EqExp { ( '&&' ) EqExp }                         | 
| 逻辑或表达式 |   LOrExp | → | LAndExp { ( '\|\|' ) LAndExp }                   |
